
function update_player(player)
  local queue = global.ghost_queues[player.index]
  while true do
    if queue and queue.next <= #queue.ghosts then
      local ghost = queue.ghosts[queue.next]
      queue.next = queue.next + 1
      if ghost.valid then
        local dx = player.position.x - ghost.position.x
        local dy = player.position.y - ghost.position.y
        if dx*dx + dy*dy <= 25 then
          for _,stack in pairs(ghost.ghost_prototype.items_to_place_this) do
            local removed = player.remove_item(stack)
            if removed == stack.count then
              if ghost.revive() then
                return
              end
            end
            if removed > 0 then
              player.insert{name=stack.name, count=removed}
            end
          end
        end
      end
    else
      local aabb =
      {
        left_top = {player.position.x - 9, player.position.y - 9},
        right_bottom = {player.position.x + 9, player.position.y + 9}
      }
      local entities = player.surface.find_entities_filtered{area=aabb, force=player.force, limit=10, type="entity-ghost"}
      if #entities == 0 then
        entities = player.surface.find_entities_filtered{area=aabb, force=player.force, limit=10, type="tile-ghost"}
      end
      global.ghost_queues[player.index] = {next = 1, ghosts = entities}
      return
    end
  end
end

script.on_init(function()
  global.ghost_queues = {}
end)
script.on_event(defines.events.on_tick, function(event)
  for _,player in pairs(game.players) do
    if ((game.tick + player.index) % 20) == 0 then
      update_player(player)
    end
  end
end)
